<?php
/**
* Gavick Gplus GK4 - helper class
* @package Joomla!
* @ Copyright (C) 2012 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: GK4 1.0 $
**/
// no direct access
defined('_JEXEC') or die('Restricted access');
// Main class
class GplusHelper {
	
	var $config = array(); // configuration array
	
	function __construct($params, $module) {
        // Basic settings
        $this->config['moduleclass_sfx'] = $params->get('moduleclass_sfx', '');
        $this->config['module_unique_id'] = $params->get('module_unique_id','gplus1');
        $this->config['comments_admin_id'] = $params->get('comments_admin_id','');
        $this->config['g_id'] = $params->get('g_id', '');
 
        // Layout Settings
        $this->config['badge_style'] = $params->get('badge_style','standard_badge');
        $this->config['lang_code'] = $params->get('lang_code','en');
        $this->config['badge_width'] = $params->get('badge_width','300');
        $this->config['badge_color'] = $params->get('badge_color','light');
        $this->config['async_script'] = $params->get('async_script', 1);
        $this->config['html5_valid'] = $params->get('html5_valid', 1);
        $this->config['custom_name'] = $params->get('custom_name', '');
        $this->config['custom_name_pos'] = $params->get('custom_name_pos', 'before');
        
	}
	// RENDERING LAYOUT
	function renderLayout() {
		// create instances of basic Joomla! classes
		$document = JFactory::getDocument();
		// init $headData variable
		$headData = false;	
		// getting module head section datas
		$headData = $document->getHeadData();
		// generate keys of script section
		$headData_keys = array_keys($headData['custom']);
		// set variable for false
		$script_founded = false;
        $link_founded = false;
		// searching gplus link in scripts paths
		if(in_array('apis.google.com/js/plusone.js', $headData_keys )) {
            $script_founded = true;
		}
		
        if(in_array('plus.google.com', $headData_keys)) {
            $link_founded = true;
        }
        
        if($this->config['badge_style'] == 'standard_badge' || $this->config['badge_style'] == 'small_badge') {
            if($this->config['async_script'] == 1) {
                // async script mode
                if($link_founded) {
                    $content = '<script type="text/javascript">
                                window.___gcfg = {lang: \''.$this->config['lang_code'].'\'};
                                (function() 
                                {var po = document.createElement("script");
                                po.type = "text/javascript"; po.async = true;po.src = "https://apis.google.com/js/plusone.js";
                                var s = document.getElementsByTagName("script")[0];
                                s.parentNode.insertBefore(po, s);
                                })();</script>';
                 } else {
                    $content = '<link href="https://plus.google.com/'.$this->config['g_id'].'" rel="publisher" /><script type="text/javascript">
                            window.___gcfg = {lang: \''.$this->config['lang_code'].'\'};
                            (function() 
                            {var po = document.createElement("script");
                            po.type = "text/javascript"; po.async = true;po.src = "https://apis.google.com/js/plusone.js";
                            var s = document.getElementsByTagName("script")[0];
                            s.parentNode.insertBefore(po, s);
                            })();</script>';
                 }
            } else {
                if($link_founded) {
                    $content = '<script type="text/javascript" src="https://apis.google.com/js/plusone.js">{lang: \''.$this->config['lang_code'].'\'}</script>';
                } else {
                    $content = '<link href="https://plus.google.com/'.$this->config['g_id'].'" rel="publisher" /><script type="text/javascript" src="https://apis.google.com/js/plusone.js">{lang: \''.$this->config['lang_code'].'\'}</script>';
                }
            }
        } else {
            $content = '<link href="https://plus.google.com/'.$this->config['g_id'].'" rel="publisher" />';
        }
		// if gplus script file doesn't exists in document head section
        if(!$script_founded && $this->config['g_id'] != '' && ($this->config['badge_style'] == 'standard_badge' || $this->config['badge_style'] == 'small_badge')){ 
            $document->addCustomTag($content);
     	} 
		// select proper layout to load
        if($this->config['badge_style'] == 'standard_badge' || $this->config['badge_style'] == 'small_badge') {
            require(JModuleHelper::getLayoutPath('mod_gplus_gk4', 'badge')); 
        } else {
            require(JModuleHelper::getLayoutPath('mod_gplus_gk4', 'icon')); 
        }
	}
}
/* eof */